A parameter is composed of a name, type and value.

Nested Parameters are also possible, but the using task/type has to support them

author | Manuel Holtgrewe
author | <a href="mailto:yl@seasonfive.com">Yannick Lecaillez</a>
package | phing.types
version | $Id$

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()

## createParam()

    createParam() : \Parameter

### Returns

`\Parameter`

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()

## getName()

    getName()

## getParams()

    getParams() : array

### Returns

`array`Nested parameters.

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()

### Returns

`\Project`Reference to current porject object

## getType()

    getType()

## getValue()

    getValue()

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()

### Parameters

#### $desc

## Sets value to dynamic register slot.

    setListeningValue(\RegisterSlot $value)

### Parameters

#### $value

`\RegisterSlot`

## setName()

    setName($name)

### Parameters

#### $name

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

Inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

inherited_from | \DataType::setRefid()

### Parameters

#### $r

`\Reference`

## setType()

    setType($type)

### Parameters

#### $type

## setValue()

    setValue($value)

### Parameters

#### $value

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked

##

    $name

##

    $parameters

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project

##

    $type

##

    $value